<template>
  <div class="period" :class="[getStatus, {'is-short': !getDetailView && !example}, {'is-example':example}]">
    <div class="period-controls">
      <button title="Close period" class="period-close" @click="closePeriod"
              v-if="!period.period_close && (getDayLeave > period.days_expired)">
        -
      </button>
      <button title="Delete period" class="period-delete" @click="deletePeriodFn" v-if="!example">
        +
      </button>
    </div>
    <!-- meta -->
    <div class="period-fieldset period-meta">
      <h2>Назва: {{period.title}}</h2>
      <div class="period-row">
        Створений: {{createdDate}}
      </div>
      <div class="period-row">
        Закінчується: {{expiredDate}}
      </div>
      <div class="period-row">
        Тривалість: {{period.days_expired}} д.
      </div>
      <div class="period-row">
        {{isClosed}}
      </div>
      <div class="period-row">
        Середній курс: {{period.exchange_course}} UAH/USD
      </div>
    </div>

    <!-- bookkeeping -->
    <div class="period-fieldset period-bookkeeping" v-show="getDetailView || example">
      <h2>Бугалтерія:</h2>
      <div class="period-groups">
        <div v-for="(fields, i) in structure" :key="i" class="period-group">
          <div class="period-group__title">
            {{fields.title}}:
          </div>
          <div class="period-groups__content">
            <div v-for="(item,i) in bookkeeping[fields.key]" :key="i" class="period-row">
              <div class="key">{{item.title}}:</div>
              <div class="value">{{item.value}} {{item.currency}}</div>
            </div>
          </div>
          <div class="period-group__total">
            <div>{{fields.title}} всього:</div>
            <div>{{totalValue[fields.key]}} {{fields.currency}}</div>
          </div>
        </div>
      </div>
    </div>

    <!-- total -->
    <div class="period-fieldset period-total" v-show="getDetailView || example">
      <h2>Підсумки:</h2>
      <div v-for="(item,i) in getTotal" :key="i" class="period-row period-total__row">
        <div class="key">{{item.title}}:</div>
        <div class="value">{{item.value}} {{item.currency}}</div>
      </div>
    </div>
  </div>
</template>

<script>
  import { mapActions, mapGetters } from 'vuex'
  import { getCurrentDayTime } from '../../heplres'
  import constant from '../../constant'

  export default {
    name: 'PeriodItem',
    data () {
      return {
        structure: constant.structure
      }
    },
    props: {
      period: {
        title: String,
        create: String,
        exchange_course: String,
        days_expired: String,
        period_close: Boolean,
        id: String,
        bookkeeping: {
          income: Object,
          taxes: Array,
          savings: Array,
          home_payments: Array,
          shopping: Array
        }
      },
      example: Boolean
    },
    methods: {
      ...mapActions(['changePeriod', 'deletePeriod']),

      formatDate (time) {
        const getTime = new Date(+time)

        return {
          day: getTime.getDate() < 10 ? `0${getTime.getDate()}` : getTime.getDate(),
          month: getTime.getMonth() + 1 < 10 ? `0${getTime.getMonth() + 1}` : getTime.getMonth() + 1,
          year: getTime.getFullYear()
        }
      },
      closePeriod () {
        const period = Object.assign({}, this.period)
        period.period_close = true

        this.changePeriod(period)
      },
      deletePeriodFn () {
        this.deletePeriod(this.period)
      }
    },
    computed: {
      ...mapGetters(['getDetailView']),
      createdDate () {
        const date = this.formatDate(this.period.create)

        return `${date.day}/${date.month}/${date.year}`
      },
      expiredDate () {
        const date = this.formatDate(+this.period.create + +this.period.days_expired * 24 * 60 * 60 * 1000)

        return `${date.day}/${date.month}/${date.year}`
      },
      isClosed () {
        return this.period.period_close ? 'Період закритий' : 'Період відкритий'
      },
      bookkeeping () {
        return this.period.bookkeeping
      },
      getDayLeave () {
        return (getCurrentDayTime() - this.period.create) / 1000 / 60 / 60 / 24
      },
      getStatus () {
        if (this.period.period_close) {
          return 'closed'
        } else {
          if (this.getDayLeave > this.period.days_expired) {
            return 'expired'
          } else {
            return ''
          }
        }
      },
      totalValue () {
        const total = {}

        this.structure.map(item => total[item.key] = this.bookkeeping[item.key].reduce((acc, curr) => acc + +curr.value, 0))

        return total
      },
      getTotal () {
        const withoutSavings = +this.totalValue.income - this.totalValue.savings
        const withoutSavingsUAH = withoutSavings * this.period.exchange_course
        const forLiving = withoutSavingsUAH - this.totalValue.shopping - this.totalValue.home_payments
        const forDayLiving = (forLiving / +this.period.days_expired).toFixed(0)
        const dayLeave = this.getDayLeave > this.period.days_expired ? this.period.days_expired : this.getDayLeave

        return [
          {
            title: 'Залишилось на витрати',
            value: withoutSavings,
            currency: 'USD'
          },
          {
            title: 'Залишилось на витрати',
            value: withoutSavingsUAH,
            currency: 'UAH'
          },
          {
            title: 'Залишилось на життя',
            value: forLiving,
            currency: 'UAH'
          },
          {
            title: 'Днів пройшло',
            value: dayLeave + ' / ' + this.period.days_expired,
            currency: ''
          },
          {
            title: 'Приблизно на день',
            value: forDayLiving,
            currency: 'UAH/день'
          },
          {
            title: 'Приблизно залишилось',
            value: this.getDayLeave > this.period.days_expired ? 0 : forLiving - forDayLiving * dayLeave,
            currency: 'UAH'
          }
        ]
      }
    }
  }
</script>

<style lang="scss" scoped>
  @import "../../styles/base/all_base_sheets";

  .period {
    display: flex;
    flex-flow: column nowrap;
    position: relative;
    padding: 20px;
    border: 1px dotted rgba($cl-black, .2);
    border-radius: 20px;
    width: 100%;
    max-width: 420px;
    @include marginCenter;

    &.is-example {
      /*margin-right: 0;*/
    }

    &.closed {
      background: rgba($cl-black, .1);
    }

    &.expired {
      background: rgba($cl-yellow, .1);
    }

    &-delete {
      @include circle(30px);
      position: absolute;
      top: 10px;
      right: 10px;
      background: none;
      box-shadow: none;
      border: none;
      padding: 0;
      -webkit-appearance: none;
      cursor: pointer;
      background: $cl-default;
      color: $cl-white;
      z-index: 10;
      outline: none;
      font-size: 20px;
      transform: rotate(45deg);
    }

    &-close {
      @include circle(30px);
      position: absolute;
      top: 10px;
      left: 10px;
      background: none;
      box-shadow: none;
      border: none;
      padding: 0;
      -webkit-appearance: none;
      cursor: pointer;
      background: $cl-black;
      color: $cl-white;
      z-index: 10;
      outline: none;
      font-size: 20px;
    }

    h2 {
      font-size: 2rem;
      font-weight: bold;
      margin-bottom: 10px;
      text-align: center;
    }

    h3 {
      font-size: 1.8rem;
      margin-bottom: 5px;
    }

    &-fieldset {
      padding-top: 21px;
      margin-top: 20px;
      position: relative;

      &:nth-last-child(2) {
        margin-bottom: 50px;
      }

      &.period-meta {
        padding-top: 0;
        margin-top: 0;

        &:before {
          display: none;
        }
      }

      &.period-total {
        margin-top: auto;
        padding-top: 20px;

        .key {
          font-weight: bold;
        }
      }

      .period.is-short & {
        margin-bottom: 0;
        padding: 0;

        &:before {
          display: none;
        }
      }

      &:before {
        content: '';
        display: block;
        width: 70%;
        height: 1px;
        background: rgba($cl-black, .2);
        position: absolute;
        top: 0;
        left: 0;
        right: 0;
        margin: auto;
      }
    }

    &-row {
      display: flex;
      flex-flow: row nowrap;
      justify-content: space-between;
    }

    &-group {
      margin-bottom: 30px;

      &:last-child {
        margin-bottom: 0;
      }

      &__title {
        font-weight: bold;
      }

      &__row {
        margin-bottom: 15px;

        &:last-child {
          margin-bottom: 0;
        }
      }

      &__content {
        margin-bottom: 6px;

        &:last-child {
          margin-bottom: 0;
        }
      }

      &__total {
        padding-top: 6px;
        font-weight: bold;
        position: relative;
        display: flex;
        justify-content: space-between;

        &:before {
          content: '';
          display: block;
          width: 100%;
          height: 1px;
          background: rgba($cl-black, .2);
          position: absolute;
          top: 0;
        }
      }
    }
  }
</style>
